                     /*-----------------------------------*/
                     /*             >>>Slip<<<            */
                     /*            Theo D'Hondt           */
                     /*     VUB Software Languages Lab    */
                     /*             (c) 2010              */
                     /*-----------------------------------*/
                     /*version 3: factored out environment*/
                     /*-----------------------------------*/
                     /*               stack               */
                     /*-----------------------------------*/

#include <string.h>

#include "SlipMain.h"

#include "SlipPool.h"

/*------------------------------ private constants ---------------------------*/

enum {   Initial_pool_size = 64,
       Pool_size_increment = 32 };

/*------------------------------ private variables ---------------------------*/

static UNS_type   Pool_size;
static VEC_type Pool_vector;
static UNS_type Top_of_Pool;

/*------------------------------ public functions ----------------------------*/

SYM_type Pool_Enter(TXT_type Text)
  { SYM_type symbol;
    TXT_type text;
    UNS_type index;
    for (index = 1;
         index < Top_of_Pool;
         index++)
      { symbol = Pool_vector[index];
        text = symbol->txt;
        if (strcmp(Text,
                   text) == 0)
          return symbol; }
    if (Top_of_Pool == Pool_size)
      { VEC_type vector = Pool_vector;
        Pool_size += Pool_size_increment;
        Pool_vector = make_VEC(Pool_size);
        for (index = 1;
             index < Top_of_Pool;
             index++)
          Pool_vector[index] = vector[index]; }
    symbol = make_SYM(Text);
    Pool_vector[Top_of_Pool++] = symbol;
    return symbol; }

NIL_type Pool_Initialize(NIL_type)
  { Pool_size = Initial_pool_size;
    Top_of_Pool = 1;
    Pool_vector = make_VEC(Initial_pool_size); }


